
       PAGE   60,132
       TITLE  Assembly routine for C.


           ;-----------------------------------------------
           ;                                              :
           ; usage:                                       :
           ;        name()                                :
           ;-----------------------------------------------

       EXTRN     _timer_latch     : WORD

TIMER_FREQ       EQU     4000H


VECTOR_SEG    SEGMENT   AT 0

       ORG    8 * 4

INT08_VECTOR_OFF   DW   ?
INT08_VECTOR_SEG   DW   ?

VECTOR_SEG    ENDS


_TEXT  SEGMENT  WORD PUBLIC 'CODE'
_TEXT  ENDS
_DATA  SEGMENT  WORD PUBLIC 'DATA'
_DATA  ENDS
CONST  SEGMENT  WORD PUBLIC 'CONST'
CONST  ENDS
_BSS   SEGMENT  WORD PUBLIC 'BSS'
_BSS   ENDS


DGROUP GROUP   CONST, _BSS, _DATA
       ASSUME  CS: _TEXT, DS: DGROUP, SS: DGROUP

       PUBLIC    _drv_version, _drv_init, _drv_terminate, _drv_instr_data
       PUBLIC    _drv_reset, _drv_start, _drv_halt, _drv_volume

_DATA  SEGMENT  WORD PUBLIC 'DATA'
       ASSUME   CS: _TEXT, DS: DGROUP, SS: DGROUP

CMSDRV_ADDX      LABEL       DWORD
    CMSDRV_OFF     DW        0
    CMSDRV_SEG     DW        ?

STATUS_ADDX      LABEL       DWORD
    STATUS_OFF     DW        ?
    STATUS_SEG     DW        ?

ORG_INT08_ADDX   LABEL       DWORD
    ORG_INT08_OFF  DW        ?
    ORG_INT08_SEG  DW        ?

FREQ_COUNT         DW        ?

INT_ON             DB        0

_DATA  ENDS


STK_DATA      STRUC

              DW   ?                   ; ret addx
              DW   ?                   ; push BP
  DATA1       DW   ?
  DATA2       DW   ?
  DATA3       DW   ?
  DATA4       DW   ?

STK_DATA      ENDS

VERSION       EQU       0
INITIAL       EQU       1
TERMINATE     EQU       2
INSTRUMENT    EQU       3
RESET         EQU       4
START         EQU       5
HALT          EQU       6
VOLUME        EQU       7
ACTIVE        EQU       8


_TEXT  SEGMENT           WORD PUBLIC 'CODE'


;------------------------------
;      set timer 0 speed      :
;                             :
; entry:                      :
;       ax = divisor          :
; exit:                       :
;       ax destroyed          :
;------------------------------

       TIME_CTL    EQU     43H
       TIME0       EQU     40H

PROG_TIMER    PROC

       PUSHF

       CLI
       PUSH   AX
       MOV    AL,00110110B
       OUT    TIME_CTL,AL
       POP    AX
       OUT    TIME0,AL
       MOV    AL,AH
       OUT    TIME0,AL

       POPF
       RET

PROG_TIMER    ENDP



_drv_version     PROC   FAR

       PUSH   BP
       MOV    BP,SP

       MOV    AX,[BP+DATA1]            ; get driver seg addx
       MOV    CMSDRV_SEG,AX            ; save for future call

       MOV    BH,VERSION
       CALL   CMSDRV_ADDX

       POP    BP
       RET

_drv_version     ENDP


_drv_init        PROC   FAR

       PUSH   BP
       MOV    BP,SP

       MOV    AX,[BP+DATA1]            ; get I/O port addx
       MOV    BH,INITIAL
       CALL   CMSDRV_ADDX

       POP    BP
       RET

_drv_init        ENDP


_drv_terminate   PROC   FAR

       PUSH   BP
       MOV    BP,SP

       MOV    BH,TERMINATE
       CALL   CMSDRV_ADDX

       POP    BP
       RET

_drv_terminate   ENDP


_drv_instr_data  PROC   FAR

       PUSH   BP
       MOV    BP,SP

       MOV    BH,INSTRUMENT
       MOV    DX,[BP+DATA2]            ; get pointer to instrument data
       MOV    AX,[BP+DATA1]
       CALL   CMSDRV_ADDX

       POP    BP
       RET

_drv_instr_data  ENDP



_drv_reset       PROC   FAR

       PUSH   BP
       MOV    BP,SP

       MOV    BH,RESET
       MOV    DX,[BP+DATA2]            ; get pointer to music piece data
       MOV    AX,[BP+DATA1]
       CALL   CMSDRV_ADDX

       POP    BP
       RET

_drv_reset       ENDP






_drv_halt        PROC   FAR

       PUSH   BP
       MOV    BP,SP

       MOV    BH,HALT
       CALL   CMSDRV_ADDX

       POP    BP
       RET

_drv_halt        ENDP



_drv_volume      PROC   FAR

       PUSH   BP

       MOV    AX,[BP+DATA1]
       MOV    BH,VOLUME
       CALL   CMSDRV_ADDX

       POP    BP
       RET

_drv_volume      ENDP   




_drv_start       PROC   FAR

       PUSH   BP
       MOV    BP,SP

       PUSH   DI
       PUSH   SI

       MOV    BH,START
       MOV    DI,[BP+DATA2]            ; get pointer to 1st midi data
       MOV    SI,[BP+DATA1]

       MOV    DX,[BP+DATA4]            ; get pointer to status word
       MOV    AX,[BP+DATA3]
       MOV    STATUS_OFF,AX
       MOV    STATUS_SEG,DX
       CALL   CMSDRV_ADDX

       PUSH   DS
       SUB    AX,AX
       MOV    DS,AX
       ASSUME DS:VECTOR_SEG

       MOV    DX,INT08_VECTOR_SEG
       MOV    CX,INT08_VECTOR_OFF

       POP    DS
       ASSUME DS:DGROUP

       MOV    ORG_INT08_SEG,DX
       MOV    ORG_INT08_OFF,CX

       MOV    DX,CS
       MOV    CX,OFFSET NEW_INT08
       CALL   SET_INT08_VECTOR

       MOV    AX,TIMER_FREQ
       CALL   PROG_TIMER

       STI

       POP    SI
       POP    DI

       POP    BP
       RET

_drv_start       ENDP



SET_INT08_VECTOR   PROC

       PUSH   DS

       SUB    AX,AX
       MOV    DS,AX
       ASSUME DS:VECTOR_SEG

       MOV    INT08_VECTOR_SEG,DX
       MOV    INT08_VECTOR_OFF,CX

       POP    DS
       ASSUME DS:DGROUP
       RET

SET_INT08_VECTOR   ENDP



NEW_INT08        PROC

       PUSHF
       PUSH   DS
       PUSH   ES
       PUSH   AX
       PUSH   BX
       PUSH   CX
       PUSH   DX
       PUSH   DI
       PUSH   SI
       PUSH   BP

       MOV    AX,DGROUP
       MOV    DS,AX
       MOV    ES,AX

       CMP    INT_ON,0
       JNZ    INT90

       MOV    INT_ON,1

       MOV    BH,ACTIVE
       CALL   CMSDRV_ADDX

       LDS    SI,STATUS_ADDX
       CMP    WORD PTR [SI],0
       MOV    AX,DGROUP
       MOV    DS,AX
       JNZ    INT10

       MOV    DX,ORG_INT08_SEG
       MOV    CX,ORG_INT08_OFF
       CALL   SET_INT08_VECTOR

       MOV    AX,_timer_latch
       CALL   PROG_TIMER
       JMP    SHORT INT80

INT10:
       ADD    FREQ_COUNT,TIMER_FREQ
       JC     INT20

       MOV    AX,_timer_latch
       CMP    FREQ_COUNT,AX
       JB     INT80

INT20:
       PUSHF
       CALL   ORG_INT08_ADDX

       MOV    AX,_timer_latch
       SUB    FREQ_COUNT,AX
       CMP    FREQ_COUNT,AX
       JNB    INT20

       JMP    SHORT INT88

INT80:
       MOV    AL,20H                   ; hardware end of int.
       OUT    20H,AL

INT88:
       MOV    INT_ON,0
       JMP    SHORT INT99

INT90:
       MOV    AL,20H                   ; hardware end of int.
       OUT    20H,AL

INT99:
       POP    BP
       POP    SI
       POP    DI
       POP    DX
       POP    CX
       POP    BX
       POP    AX
       POP    ES
       POP    DS
       POPF
       IRET

NEW_INT08        ENDP


_TEXT  ENDS
       END


