#include      <tsc.h>
#include      <dos.h>
#include      <string.h>

         unchar            far *song_buffer ;
         unchar            far *drv_buffer ;
         unchar            drv_id[] = "C/MS" ;
         unint             status_flag ;
         unint             timer_latch = 0xffff ;

         unint             file_err ;
         unchar            channel_note[] = { 01,0x11,0x21,0x31,0x41,0 } ;

         TSCREGS           tscregs ;


get_mem()
{
         unint             ret_val = FALSE ;

    if (song_buffer = tscalloc(0xffff))
    {
         if (drv_buffer = tscalloc(0x4000))
              ret_val = TRUE ;
    }

    return(ret_val) ;
}

free_mem()
{
    if (song_buffer)
    {
         tscfree(FP_SEG(song_buffer)) ;
         song_buffer = 0 ;
    }

    if (drv_buffer)
    {
         tscfree(FP_SEG(drv_buffer)) ;
         drv_buffer = 0 ;
    }
}


varify_drv(unchar far *fp)
{
       unchar      *p ;
       unchar      ret_val = TRUE ;

    for (p = drv_id; *p; fp++, p++)
    {
         if (*fp != *p)
              ret_val = FALSE ;
    }

    return(ret_val) ;
}


load_drv()
{
       unint       handle ;
       unint       ret_val = FALSE ;

    handle = Copenf("TESTVER.DRV") ;

    if (!file_err)
    {
         Creadf(handle,0x4000,drv_buffer) ;

         Cclosef(handle) ;

         if (varify_drv(drv_buffer+3))
              ret_val = TRUE ;
         else
              printf("Wrong driver.\n") ;
    }
    else
         printf("Error in openning driver file - BRODER.DRV.") ;

    return(ret_val) ;
}


load_song(unchar *filename)
{
       unint       handle ;
       unint       ret_val = FALSE ;
       unchar      *p ;

    if ( !(p=strrchr(filename,'\\')) )
         p = filename ;

    if (p=strchr(p,'.'))
         *p = 0 ;

    handle = Copenf(strcat(strupr(filename),".SMF")) ;

    if (!file_err)
    {
         Creadf(handle,0xffff,song_buffer) ;

         Cclosef(handle) ;

         ret_val = TRUE ;
    }
    else
         printf("Error in openning file - %s.\n",filename) ;

    return(ret_val) ;
}


main(unint argc,unchar *argv[])
{
         unint     key ;
         unint     temp_flag ;
         unchar    far *music_piece = (char far*)channel_note ;

    scrmode(3) ;
    printf("Creative Music System SMF Driver Sample Program.\n") ;

    if (get_mem())
    {
         if (load_drv())
         {
              printf("C/MS SMF Driver version : %X\n\n",
                         drv_version(FP_SEG(drv_buffer))) ;

              drv_init(0x220) ;

              if (argc > 1)
              {
                   if (load_song(argv[1]))
                   {
                        disable_ctrlbrk() ;

                        drv_reset(music_piece) ;
                        drv_start(song_buffer,(char far*)&status_flag) ;

                        cursor(0x300,0) ;
                        cprintf("   Flag value: ") ;

#pragma loop_opt(off)
                        while (status_flag)
                        {
                             if (keythere())
                             {
                                  key = rdkbd() ;

                                  switch(key)
                                  {
                                       case 0x011b : drv_halt() ;
                                                     cursor(0x600,0) ;
                                                     clreol() ;
                                                     cprintf("  Song stopped.") ;
                                                     break ;
                                  }

                             }

                             if (status_flag != temp_flag)
                             {
                                  cursor(0x30f,0) ;
                                  cprintf("%3d",temp_flag = status_flag) ;
                             }

                        }
#pragma loop_opt(on)

                        cursor(0x30f,0) ;
                        printf("%3d",status_flag) ;

                        cursor(0x800,0) ;

                   }
              }
              else
                   printf("SMF file not specified.\n") ;

              drv_terminate() ;
         }
    }

    free_mem() ;
}

